DEBVM-CREATE(1)

NAME
debvm-create - Create a VM image for various Debian releases and architectures

SYNOPSIS
debvm-create [-h hostname] [-k sshkey] [-o output] [-r release] [-s <task>] [-z size] [-- mmdebstrap options]

DESCRIPTION
debvm-create is essentially a thin wrapper around mmdebstrap for creating a raw ext4 filesystem image for booting with debvm-run. The purpose of these images primarily is testing the different releases and architectures without access to a physical machine of that architecture. Beyond essential packages, the image will contain apt, an init system and a suitable kernel package. Notably absent is a bootloader and a partition table. In order to boot such an image, one is supposed to extract the kernel and initrd from the image and pass it to a suitable bootloader. No user account is created and root can login without specifying a password.

OPTIONS

-h hostname, --hostname=hostname
    Set the hostname of the virtual machine. By default, the hostname is testvm.

--initsystem=systemd | busybox | finit | runit | sysv | none
    Select an init system to be used. The default is systemd independently of the Debian release. Note that when selecting none, the resulting image will not be bootable unless something else takes care of creating /sbin/init. Automatic customizations that are specific to a particular init system will be skipped when a different init system is selected. When using the finit init system consider passing --include=finit-plugins to mmdebstrap.

-k sshkey, --sshkey=sshkey
    Install the given ssh public key file into the virtual machine image for the root user. This option also causes the ssh server to be installed. By default, no key or server is installed. To connect to the vm, pass a port number to debvm-run with the -s option.

-o output, --output=output
    Specify the file name of the resulting virtual machine image. By default, it is written to rootfs.ext4.

-r release, --release=release
    Use the given Debian release. By default, unstable is being used. If you pass a complete sources.list that includes release names to mmdebstrap, you may pass an empty string here.

-s task, --skip=task
    Skip a particular task or feature. The option may be specified multiple times or list multiple tasks to be skipped by separating them with a comma. By default, no tasks are skipped. The following tasks may be skipped.

    autologin
        Do not setup the machine for automatic password-less root login on the console. This comprises the following changes that would normally be performed. Automatic root login is configured for the init systems finit, runit, systemd and sysv. Forwarding of the "TERM" kernel command line to agetty is configured. The root password is deleted such that a login does not ask for it and the system directly boots to a shell prompt.

    ext4
        Normally, mmdebstrap bootstraps to a temporary directory and we create the output ext4 image from that directory. This option causes the creation of the ext4 image to be skipped and the output file becomes a tar archive of the temporary directory instead. Such a tar archive is not suitable for being booted by debvm-run.

    ifupdown
        skips installing ifupdown configuration to automatically configure wired interfaces. This is specific to using finit, runit or sysv as init system.

    initsystem
        skips installing an init system. This is equivalent to specifying --initsystem=none.

    kernel
        skips installing a linux kernel image. This can be useful to install a kernel without a package. If a kernel is installed via mmdebstrap option "--include", automatic kernel installation is automatically skipped.

    packagelists
        reduces the package lists inside the image. The available database for dpkg is not created. The package lists used by apt are deleted. This generally produces a smaller image, but you need to run apt update before installing packages and dpkg --set-selections does not work.

    systemdnetwork
        skips installing libnss-resolve as well as automatic network configuration via systemd-networkd. This is specific to using systemd as init system.

    usrmerge
        By default debvm adds a hook to enable merged-/usr without the usrmerge package given a sufficiently recent Debian release. Without the hook, dependencies will pull the usrmerge package as needed, which may result in a larger installation.

-z size, --size=size
    Specify the minimum image size as an integer and optional unit (example: 10K is 10*1024). Units are K,M,G,T (powers of 1024). The resulting image will be grown as a sparse file to this size if necessary. The default is 2 GB.

-- mmdebstrap options
    All options beyond a double dash are passed to mmdebstrap after the suite and target specification. This can be used to provide additional hooks for image customization. You can also request additional packages to be installed into the image using mmdebstrap's --include option. Any positional arguments passed here will be treated as mirror specifications by mmdebstrap. In particular, you can also change the architecture of the resulting image using the --architecture option.

EXAMPLES
When creating an image with multiple architectures, the kernel selection will prefer the sibling 64bit architecture.

    debvm-create ... -- --architecture=armhf,arm64

In order to create images for Debian ports architectures, you can pass two options to mmdebstrap.

    debvm-create ... -- http://deb.debian.org/debian-ports --keyring=/usr/share/keyrings/debian-ports-archive-keyring.gpg

You can also install a graphical desktop environment.

    debvm-create ... -- --hook-dir=/usr/share/mmdebstrap/hooks/useradd --aptopt='Apt::Install-Recommends "true"' --include=linux-image-generic,task-gnome-desktop

Here the hook creates a password-less user "user". In order for "task-gnome-desktop" to work reasonably well, "Recommends" should be enabled. By default a "-cloud" kernel that lacks graphics drivers is installed.

Installing Ubuntu is also supported somewhat.

    debvm-create --release kinetic -- --keyring=/usr/share/keyrings/ubuntu-archive-keyring.gpg --components=main,universe --include=e2fsprogs

Note that "universe" must be enabled as the "merged-usr" and "systemdnetwork" hooks rely packages from that component. "e2fsprogs" should be pulled by "initramfs-tools".

There also is an aid for sharing a directory with the VM.

    debvm-create ... -- --include=linux-image-generic --hook-dir=/usr/share/mmdebstrap/hooks/9pmount
    debvm-run ... -- -virtfs local,security_model=none,path=/host_path,mount_tag=guest_tag

This will mount the directory "/host_path" from the host as "/media/guest_tag" in the VM during boot using 9P. Note that the "-cloud" kernel lacks the 9P filesystem driver.

SEE ALSO
    debvm-run(1) mmdebstrap(1)